Description

Hub distance in Processing (https://github.com/qgis/QGIS/blob/master/python/plugins/processing/algs/qgis/HubDistance.py)  is very slow

because it does not take advantage of spatial indexing.

Associated revisions

Revision e0c9733f - 2016-06-21 03:56 PM - Alexander Bruy

[processing] speedup Hub distance algorithm (fix #15012)

Revision c5e7a981 - 2016-06-21 03:57 PM - Alexander Bruy

[processing] speedup Hub distance algorithm (fix #15012)

(cherry picked from commit e0c9733f6482f184aeeff1339fafef210d1a0709)

Conflicts:

    python/plugins/processing/algs/qgis/HubDistance.py

History

#1 - 2016-06-12 09:38 AM - Anita Graser

What's the best way to use a spatial index in a Processing script?

This does not take selection and layer filters into account:

index = QgsSpatialIndex(layerHubs.getFeatures())

#2 - 2016-06-12 04:16 PM - Nyall Dawson

Anita - what do you mean by "layer filters"?

#3 - 2016-06-12 10:53 PM - Anita Graser

Hi Nyall, I meant the layer's "provider feature filter" is ignored by layer.getFeatures(). (Btw, I don't think this was always the case in the past.)

2025-04-26 1/2

https://github.com/qgis/QGIS/blob/master/python/plugins/processing/algs/qgis/HubDistance.py


#4 - 2016-06-13 07:57 PM - Nyall Dawson

Anita - I can't reproduce that. What's the data source? It's definitely a bug and it should be respected, and there's a even a bunch of unit tests to ensure

that...

#5 - 2016-06-13 11:40 PM - Anita Graser

Sorry, I got something wrong here. Will open a new ticket when I find the source of my issue ... I had some issue mixing

processing.tools.vector.features(layer)

and

layer.getFeatures()

...

Anyway, back to the main topic: What's the recommended way to implement a spatial index in Processing algorithms?

#6 - 2016-06-14 03:45 AM - Nyall Dawson

I'd just do (psuedocode)

If using selected features:

  index = QgsSpatialIndex(layerHubs.selectedFeaturesIterator())

Else:

   index = QgsSpatialIndex(layerHubs.getFeatures())

#7 - 2016-06-21 06:55 AM - Alexander Bruy

- Status changed from Open to Closed

Fixed in changeset commit:"e0c9733f6482f184aeeff1339fafef210d1a0709".
